///////////////////////////////////////////////////////////////////////////////
// Class C_Loader_Channel                                                         //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#ifndef _CLASS_UOBIHLLEH_C_LOADER_CHANNEL
#define _CLASS_UOBIHLLEH_C_LOADER_CHANNEL

#include "Interface.hpp"

class C_Loader_Channel: public C_Interface
{
	public:
		C_Loader_Channel();
		~C_Loader_Channel();
		static int Exist ();	
	
	protected:
		int  Run (int ChannelId);
		void CleanChannels();
		void ReadChannels ();

	private:
		typedef union T_TitleId
		{
			u64 TitleId;
			
			struct
			{
				u32 TypeId;
				u32 Id;
			} __attribute__ ((__packed__)) L2;
			
			struct
			{
				u32 TypeId;
				u8  SystemId;
				u16 Id;
				u8  Region;
			} __attribute__ ((__packed__)) L3;
		} __attribute__ ((__packed__)) T_TitleId;
		
		typedef struct T_SU_TMD
		{
			sig_rsa2048	Sign;
			tmd			TMD;
			tmd_content	Content;
		} __attribute__((packed)) T_SU_TMD ;
		
		typedef union T_SU_TIK
		{
			u8 Data [0x2a4];
			struct
			{
				sig_rsa2048	Sign;
				tik			Ticket;
			} __attribute__((packed)) TIK;
		} __attribute__((packed)) T_SU_TIK;
		
		static u8  ValidSU;
		T_TitleId * Channel_TitleId;
		
		s32 LangId;
		
		static int Compare (const void * a, const void * b);
		static int Identify_SU ();
};

#endif

///////////////////////////////////////////////////////////////////////////////
