///////////////////////////////////////////////////////////////////////////////
// Class C_Loader_Files                                                      //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#ifndef _CLASS_UOBIHLLEH_C_LOADER_FILES
#define _CLASS_UOBIHLLEH_C_LOADER_FILES

#include "Interface.hpp"


#define C_Loader_Files_MAX_FILENAME_SIZE    128


class C_Loader_Files: public C_Interface
{
	public:
		C_Loader_Files(C_FileSystem *, const char *, const char *, u8 = 8);
		~C_Loader_Files();
		
		int Run (int ChannelId);
		virtual void PostRetraceCallback (u32 Count);
		virtual void SetRedrawAll();

	protected:
		C_FileSystem *	FS;
		
		void CleanChannels();
		void ReadChannels ();
	
	private:
		typedef struct T_InternalChannel
		{
			char Filename [C_Loader_Files_MAX_FILENAME_SIZE+1];
			u8   Type;
		};
		
		T_InternalChannel * Channel_Data;
		char * 				ROMDirectory;
		char * 				AppDirectory;
		C_Loader_Files *	Interface;
		u8 DirRecur;
		
		u8 GetChannelType (C_Dir *);
};

#endif

///////////////////////////////////////////////////////////////////////////////
