///////////////////////////////////////////////////////////////////////////////
// Wii GFX Library                                                           //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#ifndef _UOBIHLLEH_C_GFX_H
#define _UOBIHLLEH_C_GFX_H


#include <gccore.h>
#include "T_image.h"

class C_GFX
{
	public:
		static T_RGB * 	VRAM;
		static s32		Height;
		static s32		Width;
		
		static void Init  ();
		static void Begin ();
		static void Flush ();
		static void End   ();
		static void PostRetraceCallback (u32 Count = 0);
		static void WaitVSync ();
		
		static void Clear				 (const T_RGB Color);
		static int  ShowImage            (T_Image Image, int X, int Y, u32 ImageId);
		static int  SetImageAlphaColor   (T_Image Image, T_RGB Color);
		static int  SetImageAlphaMask    (T_Image Image, T_Image Mask);
		static int  SetNbrImagesByHeight (T_Image * Image, u32 Height);
		static int  SetNbrImagesByNbr    (T_Image * Image, u32 Nbr);
		static int  FusionImages         (T_Image * Dest, u32 DestId, T_Image Source1, u32 Source1Id, T_Image Source2, u32 Source2Id);
		static int  FusionImages         (T_Image * Dest, T_Image Source1, u32 Source1Id, T_Image Source2, u32 Source2Id, u8 Fade);
		
		static u32  ShowCaractere (T_Image &, const char Cara, int X, int Y, T_RGB Color, bool Display=true);
		static void ShowString    (const char * Cara, int X, int Y, T_RGB Color);
		static u32  SizeOfString  (const char *);
	
	private:
		static GXRModeObj * vmode;
		static u8 	 VRAM_Page;
		static u32 * VideoRAM [2];
		static u8    HaveFlush;
		
		static u32 RGBtoYUY2  (T_RGBA RGB1, T_RGBA RGB2);
};

#endif

///////////////////////////////////////////////////////////////////////////////
