///////////////////////////////////////////////////////////////////////////////
// Resources file                                                            //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#include "../../AppConfig.h"

	.rodata

///////////////////////////////////////////////////////////////////////////////
// Blocs of code                                                             //
///////////////////////////////////////////////////////////////////////////////  

	.globl Bin_JumpCode
	.balign 16
	Bin_JumpCode:
	.incbin "../../jump/jump.bin"
	Bin_JumpCode_End:
	.globl Bin_JumpCode_Length
	Bin_JumpCode_Length: .long Bin_JumpCode_End - Bin_JumpCode   
   
	.globl Dol_Reboot
	.balign 16
	Dol_Reboot:
	.incbin "../../reboot/boot.dol"
 
	.globl Dol_WiiHbLoader
	.balign 16
	Dol_WiiHbLoader:
	.incbin "../../launcher/boot.dol" 
	
	
///////////////////////////////////////////////////////////////////////////////
// File system pictures                                                      //
///////////////////////////////////////////////////////////////////////////////  
   
	.globl pngFsFrontSD
   .balign 16
	pngFsFrontSD:
	.incbin "../ressource/fs_sd.png"
	pngFsFrontSD_End:
	.globl pngFsFrontSD_Length
	pngFsFrontSD_Length: .long pngFsFrontSD_End - pngFsFrontSD

	.globl pngFsGecko
	.balign 16
	pngFsGecko:
	.incbin "../ressource/fs_gecko.png"
	pngFsGecko_End:
	.globl pngFsGecko_Length
	pngFsGecko_Length: .long pngFsGecko_End - pngFsGecko
 
	.globl pngFsUSB
	.balign 16
	pngFsUSB:
	.incbin "../ressource/fs_usb.png"
	pngFsUSB_End:
	.globl pngFsUSB_Length
	pngFsUSB_Length: .long pngFsUSB_End - pngFsUSB
 
	.globl pngFsDVD
	.balign 16
	pngFsDVD:
	.incbin "../ressource/fs_dvd.png"
	pngFsDVD_End:
	.globl pngFsDVD_Length
	pngFsDVD_Length: .long pngFsDVD_End - pngFsDVD
 
	.globl pngFsSMB
	.balign 16
	pngFsSMB:
	.incbin "../ressource/fs_smb.png"
	pngFsSMB_End:
	.globl pngFsSMB_Length
	pngFsSMB_Length: .long pngFsSMB_End - pngFsSMB


///////////////////////////////////////////////////////////////////////////////
// Main channels pictures                                                    //
///////////////////////////////////////////////////////////////////////////////   

	.globl pngTitleWiiChannel
	.balign 16
	pngTitleWiiChannel:
	.incbin "../ressource/interface_channel.png"
	pngTitleWiiChannel_End:
	.globl pngTitleWiiChannel_Length
	pngTitleWiiChannel_Length: .long pngTitleWiiChannel_End - pngTitleWiiChannel
  
	.globl pngTitleHomebrew
	.balign 16
	pngTitleHomebrew:
	.incbin "../ressource/interface_hb.png"
	pngTitleHomebrew_End:
	.globl pngTitleHomebrew_Length
	pngTitleHomebrew_Length: .long pngTitleHomebrew_End - pngTitleHomebrew

	.globl pngTitleApps
	.balign 16
	pngTitleApps:
	.incbin "../ressource/interface_apps.png"
	pngTitleApps_End:
	.globl pngTitleApps_Length
	pngTitleApps_Length: .long pngTitleApps_End - pngTitleApps

	.globl pngTitleEmulator
	.balign 16
	pngTitleEmulator:
	.incbin "../ressource/interface_emulator.png"
	pngTitleEmulator_End:
	.globl pngTitleEmulator_Length
	pngTitleEmulator_Length: .long pngTitleEmulator_End - pngTitleEmulator

	.globl pngTitleHomebrewGC
	.balign 16
	pngTitleHomebrewGC:
	.incbin "../ressource/interface_hbgc.png"
	pngTitleHomebrewGC_End:
	.globl pngTitleHomebrewGC_Length
	pngTitleHomebrewGC_Length: .long pngTitleHomebrewGC_End - pngTitleHomebrewGC
	
	.globl pngTitleTheme
	.balign 16
	pngTitleTheme:
	.incbin "../ressource/interface_theme.png"
	pngTitleTheme_End:
	.globl pngTitleTheme_Length
	pngTitleTheme_Length: .long pngTitleTheme_End - pngTitleTheme
	

  
///////////////////////////////////////////////////////////////////////////////
// Channels pictures                                                         //
///////////////////////////////////////////////////////////////////////////////    

	.globl pngTitleWiiChannelDefault
	.balign 16
	pngTitleWiiChannelDefault:
	.incbin "../ressource/interface_channel_default.png"
	pngTitleWiiChannelDefault_End:
	.globl pngTitleWiiChannelDefault_Length
	pngTitleWiiChannelDefault_Length: .long pngTitleWiiChannelDefault_End - pngTitleWiiChannelDefault
	
	.globl pngTitleWiiChannelVC
	.balign 16
	pngTitleWiiChannelVC:
	.incbin "../ressource/interface_channel_vc.png"
	pngTitleWiiChannelVC_End:
	.globl pngTitleWiiChannelVC_Length
	pngTitleWiiChannelVC_Length: .long pngTitleWiiChannelVC_End - pngTitleWiiChannelVC
	
	.globl pngTitleWiiChannelWiiWare
	.balign 16
	pngTitleWiiChannelWiiWare:
	.incbin "../ressource/interface_channel_wiiware.png"
	pngTitleWiiChannelWiiWare_End:
	.globl pngTitleWiiChannelWiiWare_Length
	pngTitleWiiChannelWiiWare_Length: .long pngTitleWiiChannelWiiWare_End - pngTitleWiiChannelWiiWare
	

///////////////////////////////////////////////////////////////////////////////
// Zone pictures                                                             //
///////////////////////////////////////////////////////////////////////////////    

	.globl pngTitleZoneAll
	.balign 16
	pngTitleZoneAll:
	.incbin "../ressource/zone_all.png"
	pngTitleZoneAll_End:
	.globl pngTitleZoneAll_Length
	pngTitleZoneAll_Length: .long pngTitleZoneAll_End - pngTitleZoneAll

	.globl pngTitleZoneFr
	.balign 16
	pngTitleZoneFr:
	.incbin "../ressource/zone_fr.png"
	pngTitleZoneFr_End:
	.globl pngTitleZoneFr_Length
	pngTitleZoneFr_Length: .long pngTitleZoneFr_End - pngTitleZoneFr
	
	.globl pngTitleZoneGe
	.balign 16
	pngTitleZoneGe:
	.incbin "../ressource/zone_ge.png"
	pngTitleZoneGe_End:
	.globl pngTitleZoneGe_Length
	pngTitleZoneGe_Length: .long pngTitleZoneGe_End - pngTitleZoneGe
	
	.globl pngTitleZoneJp
	.balign 16
	pngTitleZoneJp:
	.incbin "../ressource/zone_jp.png"
	pngTitleZoneJp_End:
	.globl pngTitleZoneJp_Length
	pngTitleZoneJp_Length: .long pngTitleZoneJp_End - pngTitleZoneJp
	
	.globl pngTitleZoneKr
	.balign 16
	pngTitleZoneKr:
	.incbin "../ressource/zone_kr.png"
	pngTitleZoneKr_End:
	.globl pngTitleZoneKr_Length
	pngTitleZoneKr_Length: .long pngTitleZoneKr_End - pngTitleZoneKr
	
	.globl pngTitleZonePal
	.balign 16
	pngTitleZonePal:
	.incbin "../ressource/zone_pal.png"
	pngTitleZonePal_End:
	.globl pngTitleZonePal_Length
	pngTitleZonePal_Length: .long pngTitleZonePal_End - pngTitleZonePal
	
	.globl pngTitleZoneUs
	.balign 16
	pngTitleZoneUs:
	.incbin "../ressource/zone_us.png"
	pngTitleZoneUs_End:
	.globl pngTitleZoneUs_Length
	pngTitleZoneUs_Length: .long pngTitleZoneUs_End - pngTitleZoneUs


///////////////////////////////////////////////////////////////////////////////
// Interface pictures                                                        //
///////////////////////////////////////////////////////////////////////////////

	.globl pngThumbEmpty
	.balign 16
	pngThumbEmpty:
	.incbin "../ressource/Empty.png"
	pngThumbEmpty_End:
	.globl pngThumbEmpty_Length
	pngThumbEmpty_Length: .long pngThumbEmpty_End - pngThumbEmpty

	.globl pngBackground
	.balign 16
	pngBackground:
	.incbin "../ressource/Bkgr.png"
	pngBackground_End:
	.globl pngBackground_Length
	pngBackground_Length: .long pngBackground_End - pngBackground

	.globl pngBar
	.balign 16
	pngBar:
	.incbin "../ressource/Bar.png"
	pngBar_End:
	.globl pngBar_Length
	pngBar_Length: .long pngBar_End - pngBar

	.globl pngThumbSelect
	.balign 16
	pngThumbSelect:
	.incbin "../ressource/Select.png"
	pngThumbSelect_End:
	.globl pngThumbSelect_Length
	pngThumbSelect_Length: .long pngThumbSelect_End - pngThumbSelect

	.globl pngThumbSprite
	.balign 16
	pngThumbSprite:
	.incbin "../ressource/Sprite.png"
	pngThumbSprite_End:
	.globl pngThumbSprite_Length
	pngThumbSprite_Length: .long pngThumbSprite_End - pngThumbSprite

	.globl pngThumbUsed
	.balign 16
	pngThumbUsed:
	.incbin "../ressource/Used.png"
	pngThumbUsed_End:
	.globl pngThumbUsed_Length
	pngThumbUsed_Length: .long pngThumbUsed_End - pngThumbUsed

	.globl pngThumbDefault
	.balign 16
	pngThumbDefault:
	.incbin "../ressource/Default.png"
	pngThumbDefault_End:
	.globl pngThumbDefault_Length
	pngThumbDefault_Length: .long pngThumbDefault_End - pngThumbDefault

	.globl pngFont
	.balign 16
	pngFont:
	.incbin "../ressource/Font.png"
	pngFont_End:
	.globl pngFont_Length
	pngFont_Length: .long pngFont_End - pngFont
	
	.globl pngFontLight
	.balign 16
	pngFontLight:
	.incbin "../ressource/FontLight.png"
	pngFontLight_End:
	.globl pngFontLight_Length
	pngFontLight_Length: .long pngFontLight_End - pngFontLight

	.globl pngTitle
	.balign 16
	pngTitle:
	.incbin "../ressource/Title.png"
	pngTitle_End:
	.globl pngTitle_Length
	pngTitle_Length: .long pngTitle_End - pngTitle

	.globl pngLeft
	.balign 16
	pngLeft:
	.incbin "../ressource/Left.png"
	pngLeft_End:
	.globl pngLeft_Length
	pngLeft_Length: .long pngLeft_End - pngLeft

	.globl pngRight
	.balign 16
	pngRight:
	.incbin "../ressource/Right.png"
	pngRight_End:
	.globl pngRight_Length
	pngRight_Length: .long pngRight_End - pngRight

	.globl pngButton1
	.balign 16
	pngButton1:
	.incbin "../ressource/Button1.png"
	pngButton1_End:
	.globl pngButton1_Length
	pngButton1_Length: .long pngButton1_End - pngButton1

	.globl pngButton2
	.balign 16
	pngButton2:
	.incbin "../ressource/Button2.png"
	pngButton2_End:
	.globl pngButton2_Length
	pngButton2_Length: .long pngButton2_End - pngButton2

	.globl pngTitleWiiBar
	.balign 16
	pngTitleWiiBar:
	.incbin "../ressource/WiiBar.png"
	pngTitleWiiBar_End:
	.globl pngTitleWiiBar_Length
	pngTitleWiiBar_Length: .long pngTitleWiiBar_End - pngTitleWiiBar
 
	.globl pngMessageBox
	.balign 16
	pngMessageBox:
	.incbin "../ressource/MsgBox.png"
	pngMessageBox_End:
	.globl pngMessageBox_Length
	pngMessageBox_Length: .long pngMessageBox_End - pngMessageBox
 	
	.globl pngDirectory
	.balign 16
	pngDirectory:
	.incbin "../ressource/dir.png"
	pngDirectory_End:
	.globl pngDirectory_Length
	pngDirectory_Length: .long pngDirectory_End - pngDirectory

	
	
#ifdef ENABLE_IR_CURSOR
	.globl pngCursor
	.balign 16
	pngCursor:
	.incbin "../ressource/cursor.png"
	pngCursor_End:
	.globl pngCursor_Length
	pngCursor_Length: .long pngCursor_End - pngCursor
#endif
  

///////////////////////////////////////////////////////////////////////////////
// Sounds                                                                    //
///////////////////////////////////////////////////////////////////////////////  
#ifdef ENABLE_MP3 

	.globl mp3Intro
	.balign 32
	mp3Intro:
	.incbin "../ressource/Intro.mp3"
	mp3Intro_End:
	.globl mp3Intro_Length
	mp3Intro_Length: .long  mp3Intro_End - mp3Intro

	.globl mp3Loop
	.balign 32
	mp3Loop:
	.incbin "../ressource/loop.mp3"
	mp3Loop_End:
	.globl mp3Loop_Length
	mp3Loop_Length: .long  mp3Loop_End - mp3Loop
  
#endif
///////////////////////////////////////////////////////////////////////////////  
