///////////////////////////////////////////////////////////////////////////////
// Classes C_Wiiload                                                         //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#ifndef _CLASS_UOBIHLLEH_C_WIILOAD
#define _CLASS_UOBIHLLEH_C_WIILOAD

#include <gctypes.h>
#include "interface.hpp"

class C_Wiiload
{
	public:
		u8   * Data;
		char * args;
		u32    FileSize;
		
		C_Wiiload  (u16 Port = 4299);
		~C_Wiiload ();
		int  Read  ();
		void StartService (C_Interface * MyInterface);

	private:
		typedef char    T_wiiload_MAGIC [4];
		
		typedef struct  T_wiiload_Version
		{
			u8 Major;
			u8 Minor;
		} __attribute__((__packed__)) T_wiiload_Version;
		
		typedef struct T_wiiload_Header
		{
			u16 ArgsLenght;
			u32 FileSize;
		} __attribute__((__packed__)) T_wiiload_Header;
		
		u16   Port;
		lwp_t ProcessId;
		C_Interface * Interface;
		
		static void * Process (void * arg);
};

#endif

///////////////////////////////////////////////////////////////////////////////
