///////////////////////////////////////////////////////////////////////////////
// Loader main program                                                       //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#include <gccore.h>
#include <stdio.h>
#include <string.h>
#include "../../common.h"

#include "app_dol.hpp"
#include "app_elf.hpp"
#include "processor.h"
#include "asm.h"
#include "AppConfig.h"

///////////////////////////////////////////////////////////////////////////////
// Don't reload IOS at startup...
s32 IOS_GetPreferredVersion() { return -1; }
///////////////////////////////////////////////////////////////////////////////

int main (int argc, char **argv) 
{
	T_WHL_Common_Ressources * WHL_Common;
	void (*Reload)() = (void(*)())0x80001800;	
	void (*EntryPoint)();
	C_App * App = NULL;
	u32 Level = 0;
	
	WHL_Common = GET_GLOBAL_PARAM_ADRESS;
	if (is_WHL_Common_Ressources(WHL_Common) == false) { Reload(); }

	if (C_App_elf::isElf(WHL_Common->Data))
	{ App = new C_App_elf(); } else { App = new C_App_dol(); }
	EntryPoint = (void(*)()) App->Load (WHL_Common->Data, NULL, APP_ACTION_RUN);
	Reload = WHL_Common->ep_Reboot;
	SYS_ResetSystem(SYS_SHUTDOWN, 0, 0);
	_CPU_ISR_Disable (Level);
	EntryPoint();
	Reload();
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
