///////////////////////////////////////////////////////////////////////////////
// Reboot code - Main program                                                //
// Created by Hell Hibou (2008)                                              //
// Part of Wii Homebrew Launcher                                             //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


#include "../../AppConfig.h"
#include "../../common.h"

#include <gccore.h>
#include <unistd.h>
#include <string.h>

int LaunchTitle (u64 TitleID);

///////////////////////////////////////////////////////////////////////////////
// Use IOS9 at startup...
s32 IOS_GetPreferredVersion() { return 9; }
///////////////////////////////////////////////////////////////////////////////

int main (void) 
{
	*((u64*) 0x80000000) = 0x0LL;
	
	if (LaunchTitle (REBOOT_TITLE_ID) < 0)
	{
		// LaunchTitle(CHANNEL_ID_SYSTEM);
		WII_Initialize();
		WII_ReturnToMenu(); 
	}
	
	return 0;
}

///////////////////////////////////////////////////////////////////////////////

int LaunchTitle(u64 TitleID)
{
	static tikview viewdata[0x10] ATTRIBUTE_ALIGN(32);
	int RetVal;
	u32 views;

	RetVal = ES_GetNumTicketViews(TitleID, &views);
	if (RetVal < 0)	{ return -1; }
	if (!views)		{ return -1; }
	if (views > 16)	{ return -1; }

	RetVal = ES_GetTicketViews(TitleID, viewdata, views);

	switch (RetVal)
	{
		case ES_EINVAL:
		case ES_ENOMEM:
		case ES_ENOTINIT:
		case ES_EALIGN:
			return -1;
			break;
	}

	return ES_LaunchTitle(TitleID, &viewdata[0]);
}

///////////////////////////////////////////////////////////////////////////////
